//+------------------------------------------------------------------+
//|                                                     Osc_test.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//---- input parameters
extern int       Kperiod=5;
extern int       Dperiod=3;
extern int       slowPeriod=3;
extern int       UpLevel=90;
extern int       DownLevel=10;
extern int       StopLoss=100;
extern int       TakeProfit=100;
extern double    Lots=0.1;

//  " "
#define OP_BALANCE 6


//   
extern int  TradeDay                   = 0; 
extern bool ReversDay                  = false;

//   
extern bool ReversTradeSignal          = false;

//    
extern bool TradeSignalEveryTick       = false;
extern int  TradeSignalBarPeriod       = 0;

//    
extern bool ModifyMarketOrderEveryTick = false;
extern bool ModifyPendingEveryTick     = false;
extern int  ModifyMarketBarPeriod      = 0;
extern int  ModifyPendingBarPeriod     = 0;

// 
extern int  Slippage                   = 3; // 
extern int  ExpertMagicNumber          = 0; //     


double Tickets[][9];//      "" :
// Tickets[][0] -  
// Tickets[][1] -  
// Tickets[][2] - lots
// Tickets[][3] - open price
// Tickets[][4] - Stop Loss
// Tickets[][5] - TakeProfit
// Tickets[][6] - MagicNumber
// Tickets[][7] - expiration time
// Tickets[][8] - open time
// 

double newSL_and_TP[][5];//      SL  TP
// newSL_and_TP[][0] -    
// newSL_and_TP[][1] -   SL
// newSL_and_TP[][2] -   TP
// newSL_and_TP[][3] -    (  )
// newSL_and_TP[][4] - 0    1   )

string CommentsTicket[100][2]; //     . 100   
// CommentsTicket[][0] -  
// CommentsTicket[][1] -   

//+------------------------------------------------------------------+
//|      ,        |
//+------------------------------------------------------------------+
int getCorrectTimeFrame(int period)
   {
   int res=period;
//----
   switch (period)
      {
      case PERIOD_D1:  break;  //  ,   
      case PERIOD_H4:  break;  //  ,   
      case PERIOD_H1:  break;  //  ,   
      case PERIOD_M30: break;  //  ,   
      case PERIOD_M15: break;  //  ,   
      case PERIOD_M5:  break;  //  ,   
      case PERIOD_M1:  break;  //  ,   
      default: res=Period();   //   ,   
      }
//----
   return(res);      
   }
//+------------------------------------------------------------------+
//|                               |
//+------------------------------------------------------------------+
void StartMessage()
   {
   int i=0;
   string currString="";
   string array[3];
//----
   array[0]=StringConcatenate(" ",WindowExpertName(),"   :");

   if (TradeSignalEveryTick)
      array[1]="1)    ; ";
   else       
      array[1]=StringConcatenate("1)        ",TradeSignalBarPeriod," ;");

   if (TradeDay==0)   //    
      array[2]="2)   ; ";
   else 
      {
      if (ReversDay) //      
         array[2]=StringConcatenate("2)   ,    ",TradeDay);
      else           //       
         array[2]=StringConcatenate("2)      ",TradeDay);
      }
   for ( i=0;i<3;i++) currString=StringConcatenate(currString,"\n",array[i]);
   Comment(currString);

   for (i=2;i>=0;i--) Print(array[i]);
   
//----
   }
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   TradeSignalBarPeriod=getCorrectTimeFrame(TradeSignalBarPeriod);   
   StartMessage(); //   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
//----
   return(0);
  }
  
//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
int yourFunction(int workPeriod)
   {
   int res=OP_BALANCE;
//----
   double prevValue = iStochastic(Symbol(),workPeriod,Kperiod,Dperiod,slowPeriod,MODE_SMA,0,MODE_SIGNAL,2);
   double currValue = iStochastic(Symbol(),workPeriod,Kperiod,Dperiod,slowPeriod,MODE_SMA,0,MODE_SIGNAL,1);

   if (currValue>DownLevel && prevValue<DownLevel) res=OP_BUY;
   if (currValue<UpLevel && prevValue>UpLevel) res=OP_SELL;

//----
   return (res);   
   }  
  
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
// tradeDay -  ,    ,    -   
//
// useReversTradeDay -   true,       
//
// everyTick  -   true,       
//
// period -  everyTick==false,         
int getTradeSignal(int tradeDay,          //   0
                   bool useReversTradeDay,//   false
                   bool everyTick,        //    
                    int period            //      
                   )
   {
   int signal=OP_BALANCE;
//----
   if (tradeDay!=0)  //    
      {
      // ,     
      if (useReversTradeDay && tradeDay==DayOfWeek()) return(signal);
      
      //   ,    tradeDay 
      if (!useReversTradeDay && tradeDay!=DayOfWeek()) return(signal);

      }

   if (!everyTick) //       
      { //         period 
      if (!isNewBar(period)) return(signal); //     
      }
//   yourFunction()  /
   signal=yourFunction(period);
   
//----
   return(signal);   
   }
//+------------------------------------------------------------------+
//|          |
//+------------------------------------------------------------------+
bool isNewBar(int timeFrame)
   {
   bool res=false;
   
   //      () 
   //  7 () 
   static datetime _sTime[7];  
   int i=6;

   switch (timeFrame) 
      {
      case 1  : i=0; break;
      case 5  : i=2; break;
      case 15 : i=3; break;
      case 30 : i=4; break;
      case 60 : i=5; break;
      case 240: break;
      case 1440:break;
      default:  timeFrame = 1440;
      }
//----
   if (_sTime[i]==0 || _sTime[i]!=iTime(Symbol(),timeFrame,0))
      {
      _sTime[i] = iTime(Symbol(),timeFrame,0);
      res=true;
      }
      
//----
   return(res);   
   }

//+------------------------------------------------------------------+
//|  true,        |
//+------------------------------------------------------------------+
bool isOurOrder(int ticket)
   {
   bool res=false;
   
   //       !
   if (IsTesting()) return(true);//    

   int temp;
//----
   for (int i=0;i<5;i++)
      {
      if (GlobalVariableCheck(WindowExpertName()+"_ticket_"+i))
         {//    
            temp=GlobalVariableGet(WindowExpertName()+"_ticket_"+i);
            if (temp==ticket)
               { //  ..    ticket
               res=true;  //   
               break;
               }
         }
      }
//----
   return(res);   
   }
//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
void PrepareTickets(double & arrayTickets[][9], string & comm[][2],int MN)
   {
   int count=0;   //  
   
   //    ,      
   ArrayResize(arrayTickets,20);
//----
   int total=OrdersTotal();
   for (int i=0;i<total;i++)
      {
      bool ourTicket=false;
      if (OrderSelect(i,SELECT_BY_POS))
         {
         if (isOurOrder(!OrderTicket()))
            {//      
            //    

            //   Symbol
            if (OrderSymbol()!= Symbol()) continue;
         
            //   ...
            // ....
         
            //   MagicNumber
            if (OrderMagicNumber()!=ExpertMagicNumber) continue;
         
            }
         //    ,    
         //   
         arrayTickets[count][0] = OrderTicket();
         arrayTickets[count][1] = OrderType();
         arrayTickets[count][2] = OrderLots();
         arrayTickets[count][3] = OrderOpenPrice();
         arrayTickets[count][4] = OrderStopLoss();
         arrayTickets[count][5] = OrderTakeProfit();
         arrayTickets[count][6] = OrderMagicNumber();
         arrayTickets[count][7] = OrderExpiration();
         arrayTickets[count][8] = OrderOpenTime();

         comm[count][0] = OrderSymbol();
         comm[count][1] = OrderComment();
         //     
         count++;
         }
      }
   
   //       .  
   ArrayResize(arrayTickets,count);
   //ArrayResize(comm,count);

//----
   return;   
   }

//+------------------------------------------------------------------+
//|    Stop Loss                                     |
//+------------------------------------------------------------------+
double getNewSL(int    type,      //  ,   
                double lots,      // ,  
                double openPrice, //  
                double stopLoss,  //   Stop Loss
                double takeProfit //   Take Profit
                )
   {
   double res=-1;
//----
//     Stop Loss
//----
   return(res);   
   }

//+------------------------------------------------------------------+
//|     Take Profit                                  |
//+------------------------------------------------------------------+
double getNewTP(int    type,      //  ,   
                double lots,      // ,  
                double openPrice, //  
                double stopLoss,  //   Stop Loss
                double takeProfit //   Take Profit
                )
   {
   double res=-1;
//----
//     Take Profit
//----
   return(res);   
   }

//+------------------------------------------------------------------+
//|                 |
//+------------------------------------------------------------------+
double getNewOpenPricePending(int    type,      //  ,   
                              double lots,      // ,  
                              double openPrice, //  
                              double stopLoss,  //   Stop Loss
                              double takeProfit //   Take Profit
                              )
   {
   double res=-1;
//----
//       

//----
   return(res);   
   }

//+------------------------------------------------------------------+
//|        SL  TP               |
//+------------------------------------------------------------------+
void CalculateSL_and_TP(bool ReversTrade,       //   
                      double arrayTickets[][9], //  "" 
                      double & arraySL_TP[][5]  //   SL, TP  openPrice
                      )
   {
   //      !!
   ArrayResize(arraySL_TP,0);
//----
   int    i,size=ArrayRange(arrayTickets,0);
   int    sizeSL_TP=0;
   double lots, openPrice, SL,TP;
   double newSL,newTP, newOpen;
   double oldOpenPrice, oldSL,oldTP;    
   //    ,     
   if (size==0) return;

   int type,ticket,oldType;
   for (i=0;i<size;i++)
      {
      ticket    = arrayTickets[i][0]; // 
      type      = arrayTickets[i][1]; // 
      lots      = arrayTickets[i][2]; // 
      openPrice = arrayTickets[i][3]; //  
      SL        = arrayTickets[i][4]; //Stop Loss
      TP        = arrayTickets[i][5]; //Take Profit
      
      if (ReversTrade) //       
         {
         switch (type)
            {
            case OP_BUY      : oldType = OP_SELL     ; break;
            case OP_SELL     : oldType = OP_BUY      ; break;
            case OP_BUYLIMIT : oldType = OP_SELLSTOP ; break;
            case OP_SELLLIMIT: oldType = OP_BUYSTOP  ; break;
            case OP_BUYSTOP  : oldType = OP_SELLLIMIT; break;
            case OP_SELLSTOP : oldType = OP_BUYLIMIT ; break;
            default: Print("   Type=",type,"   CalculateSL_and_TP()!!!");                           
            }

         double temp;
         int spread = MarketInfo(Symbol(),MODE_SPREAD);
         int digits = MarketInfo(Symbol(),MODE_DIGITS);
         if (type==OP_BUY || type==OP_BUYSTOP || type==OP_BUYLIMIT)  
            {
            temp = SL;
            if (TP!=0) oldSL = NormalizeDouble(TP+Point*spread,digits);
               else oldSL=0;
               
            if (SL!=0) oldTP = NormalizeDouble(temp+Point*spread,digits);
               else oldTP=0;
               
            oldOpenPrice = NormalizeDouble(openPrice - Point*spread,digits);
            }
         if (type==OP_SELL) 
            {
            temp = SL;
            if (TP!=0) oldSL = NormalizeDouble(TP-Point*spread,digits);
               else oldSL=0;
            
            if (SL!=0) oldTP = NormalizeDouble(temp-Point*spread,digits);
               else oldTP=0;
            
            oldOpenPrice = NormalizeDouble(openPrice + Point*spread,digits);
            }
         }
      else   //   
         {
         oldOpenPrice = openPrice;
         oldSL = SL;
         oldTP = TP;
         }
      
      newSL  = getNewSL(oldType,lots,oldOpenPrice,oldSL,oldTP);
      newTP  = getNewTP(oldType,lots,oldOpenPrice,oldSL,oldTP);
      
      //    -    
      if (type>OP_SELL) newOpen=getNewOpenPricePending(type,lots,openPrice,oldSL,oldTP);
      
      if (newSL>0 || newTP>0 || newOpen>0)
         {
         sizeSL_TP=ArrayRange(arraySL_TP,0);
         arraySL_TP[sizeSL_TP][0] = arrayTickets[i][0]; //   
         if (newSL>0) arraySL_TP[sizeSL_TP][1] = newSL; //   SL
            else      arraySL_TP[sizeSL_TP][1] = arrayTickets[i][4];
            
         if (newTP>0) arraySL_TP[sizeSL_TP][2] = newTP; //   TP
            else      arraySL_TP[sizeSL_TP][2] = arrayTickets[i][5];
         if (newOpen>0)arraySL_TP[sizeSL_TP][3] = newOpen; //   
            else       arraySL_TP[sizeSL_TP][3] = arrayTickets[i][3];
         if (type>OP_SELL) arraySL_TP[sizeSL_TP][4]=1; //  
            else           arraySL_TP[sizeSL_TP][4]=0; //  
         }
      }         
//----
   return;
   }

//+------------------------------------------------------------------+
//|                         |
//+------------------------------------------------------------------+
void CalculateNewMarketValues(int    trSignal,
                              int    & marketType,
                              double & marketLots, 
                              double & marketSL,
                              double & marketTP,
                              string & marketcomment
                              )
   {
   //     - 
   if (trSignal==OP_BALANCE) return;

   marketType    =-1; //  ,    
   marketLots    = 0;
   marketSL      = 0;
   marketTP      = 0;
   marketcomment = "";


//----
   //        

   if (trSignal==OP_BUY  && StopLoss!=0) marketSL = Bid - StopLoss*Point;
   if (trSignal==OP_SELL && StopLoss!=0) marketSL = Ask + StopLoss*Point;

   if (trSignal==OP_BUY  && TakeProfit!=0) marketTP = Bid + TakeProfit*Point;
   if (trSignal==OP_SELL && TakeProfit!=0) marketTP = Ask - TakeProfit*Point;

   marketLots = Lots;

   if (trSignal==OP_BUY) marketType = OP_BUY;
   if (trSignal==OP_SELL) marketType = OP_SELL;

   marketcomment="test";
//----
   return;   
   }  

//+------------------------------------------------------------------+
//|                 |
//+------------------------------------------------------------------+
void CalculateNewPendingValues(int    trSignal, 
                               int    & pendingType, 
                               double & pendingOpenPrice, 
                               double & pendingLots, 
                               double & pendingSL, 
                               double & pendingTP, 
                               string & pendingComment)
   {
   //     - 
   if (trSignal==OP_BALANCE) return;

   pendingType      = -1; 
   pendingOpenPrice = 0; 
   pendingLots      = 0; 
   pendingSL        = 0; 
   pendingTP        = 0; 
   pendingComment   = 0;
//----
   //      
//----
   return;
   } 

//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
void  ModifyMarkets(bool Revers,
                    bool ModifyEveryTick,
                    int  ModifyBarPeriod,
                    double newSL_and_TP[][])
   {
   int i,type,ticket,size=ArrayRange(newSL_and_TP,0);
   if (size==0) return;  //   - 

   bool res;
//----
   if (!ModifyEveryTick )//      
      {   
      if (!isNewBar(ModifyBarPeriod)) return;   //    
      }

   if (!Revers) //   
      {
      for (i=0;i<size;i++)
         {
         type=newSL_and_TP[i][4];
         if (type!=0) continue; //    -  
         ticket=newSL_and_TP[i][0];
         res=OrderModify(ticket,newSL_and_TP[i][3],newSL_and_TP[i][1],newSL_and_TP[i][2],0);
         if (!res)//   
            {
            Print(" #",ticket,"   .  ",GetLastError());
            //   
            }
         }
       }  
   else  //   ,   SL  TP 
      {
      for (i=0;i<size;i++)
         {
         type=newSL_and_TP[i][4];
         if (type!=0) continue; //    -  
         ticket=newSL_and_TP[i][0];
         res=OrderModify(ticket,newSL_and_TP[i][3],newSL_and_TP[i][2],newSL_and_TP[i][1],0);
         if (!res)//   
            {
            Print(" #",ticket,"   .  ",GetLastError());
            //   
            }
         }
      }         

//----
   return;   
   }
   
//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
void  ModifyPendings(bool Revers,
                    bool ModifyEveryTick,
                    int  ModifyBarPeriod,
                    double newSL_and_TP[][])
   {
   int i,type,ticket,size=ArrayRange(newSL_and_TP,0);
   if (size==0) return;  //   - 

   bool res;
//----
   if (!ModifyEveryTick )//      
      {   
      if (!isNewBar(ModifyBarPeriod)) return;   //    
      }

   if (!Revers) //   
      {
      for (i=0;i<size;i++)
         {
         type=newSL_and_TP[i][4];
         if (type==0) continue; //     -  
         ticket=newSL_and_TP[i][0];
         res=OrderModify(ticket,newSL_and_TP[i][3],newSL_and_TP[i][1],newSL_and_TP[i][2],0);
         if (!res)//   
            {
            Print(" #",ticket,"   .  ",GetLastError());
            //   
            }
         }
       }  
   else  //   ,   SL  TP 
      {
      for (i=0;i<size;i++)
         {
         type=newSL_and_TP[i][4];
         if (type==0) continue; //     -  
         ticket=newSL_and_TP[i][0];
         res=OrderModify(ticket,newSL_and_TP[i][3],newSL_and_TP[i][2],newSL_and_TP[i][1],0);
         if (!res)//   
            {
            Print(" #",ticket,"   .  ",GetLastError());
            //   
            }
         }
      }         

//----
   return;   
   }
   
//+------------------------------------------------------------------+
//|                               |
//+------------------------------------------------------------------+
void PrepareTicketsToClose(int signal, bool Revers, int & ticketsClose[][2], double & lots[],double arrayTickets[][9])
   {
   int size=ArrayRange(arrayTickets,0);
//----
   if (size==0) return;

   int i,type,ticket,closeSize;
   for (i=0;i<size;i++)
      {
      type=arrayTickets[i][1];
      //     ,  
      if (type>OP_SELL) continue;

      if (Revers) //    
         {
         if (type==OP_BUY) type=OP_SELL; else type=OP_BUY;
         }
      
      //        
      //          
      if (type==OP_BUY)
         {
         //  
         //    
         
         //  
         if (signal==OP_BUY) continue;
         }
      
      if (type==OP_SELL)
         {
         //  
         //    
         
         //  
         if (signal==OP_SELL) continue;
         }

      closeSize=ArrayRange(ticketsClose,0);
      ArrayResize(ticketsClose,closeSize+1);
      ArrayResize(lots,closeSize+1);
      ticketsClose[closeSize][0] = arrayTickets[i][0]; // # 
      ticketsClose[closeSize][1] = arrayTickets[i][1]; //  
      
      //      
      lots[closeSize] = arrayTickets[i][2]; //  
      //   ,     
      }
//----
   return;   
   }

//+------------------------------------------------------------------+
//|              |
//+------------------------------------------------------------------+
void PrepareTicketsToDelete(int signal, bool Revers, int & ticketsDelete[],double arrayTickets[][9])
   {
   int size=ArrayRange(arrayTickets,0);
//----
   if (size==0) return;
   ArrayResize(ticketsDelete,0);

   int i,type,ticket,deleteSize;
   for (i=0;i<size;i++)
      {
      type=arrayTickets[i][1];
      //     ,  
      if (type<=OP_SELL) continue;
      
      if (Revers) //    
         {
         switch (type)
            {
            case OP_BUYLIMIT : type = OP_SELLSTOP ; break;
            case OP_SELLLIMIT: type = OP_BUYSTOP  ; break;
            case OP_BUYSTOP  : type = OP_SELLLIMIT; break;
            case OP_SELLSTOP : type = OP_BUYLIMIT ; break;
            }
         }

      //        
      //        
      //    ,      
      //   OP_BUYLIMIT  OP_BUYSTOP
      //     
      if (type==OP_BUYLIMIT || OP_BUYSTOP)
         {
         //  
         //    
         //  
         if (signal==OP_BUY) continue;
         }
      
      if (type==OP_SELLLIMIT || OP_SELLSTOP)
         {
         //  
         //    
         //  
         if (signal==OP_SELL) continue;
         }

      deleteSize=ArraySize(ticketsDelete);
      ArrayResize(ticketsDelete,deleteSize+1);
      ticketsDelete[deleteSize] = arrayTickets[i][0];
      }
//----
   return;   
   }
//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
void CloseMarketOrders(int ticketsArray[][2], double lotsArray[])
   {  
//----
   int i,size=ArrayRange(ticketsArray,0);
   if (size==0) return;
   
   int ticket,type;
   double lots;
   bool res;
   
   int total=OrdersTotal(); 
   
   for (i=0;i<size;i++)
      {
      ticket = ticketsArray[i][0];
      type   = ticketsArray[i][1];
      lots   = lotsArray[i];
      RefreshRates(); //        

      //   
      if (type==OP_BUY)
         {
         res = OrderClose(ticket,lots,Bid,Slippage,Orange);
         if (!res)
            {
            Print("      #",ticket,"!   ",GetLastError());
            //    ,  
            }
         }

      //    
      if (type==OP_SELL)
         {
         res = OrderClose(ticket,lots,Ask,Slippage,Orange);
         if (!res)
            {
            Print("      #",ticket,"!   ",GetLastError());
            //    ,  
            }
         }

      } 
//----
   return;
   }

//+------------------------------------------------------------------+
//|                        |
//+------------------------------------------------------------------+
void DeletePendingOrders(int ticketsArray[])
   {  
//----
   int i,size=ArraySize(ticketsArray);
   if (size==0) return;
   
   int ticket;
   bool res;

   //    
   for (i=0;i<size;i++)
      {
      ticket = ticketsArray[i];
      res = OrderDelete(ticket);
      if (!res)
         {
         Print("    #",ticket,"!   ",GetLastError());
         //    ,  
         }
      } 
//----
   return;
   }

//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
void OpenMarketOrder(bool   reversTrade,//   
                     int    Type,       //   - OP_BUY  OP_SELL
                     double lots,       //   
                     double SL,         //  Stop Loss
                     double TP,         //  TakeProfit
                     string comment)    //   
   {
   int openType;
   
   if (reversTrade)                       //  
      {
      double temp;
      int spread = MarketInfo(Symbol(),MODE_SPREAD);
      int digits = MarketInfo(Symbol(),MODE_DIGITS);
      if (Type==OP_BUY)  
         {
         openType = OP_SELL; //   
         temp = SL;
         if (TP!=0) SL = NormalizeDouble(TP+Point*spread,digits);
            else SL=0;
         if (temp!=0) TP = NormalizeDouble(temp+Point*spread,digits);
            else TP=0;
         }
      if (Type==OP_SELL) 
         {
         openType = OP_BUY;  //   
         temp = SL;
         if (TP!=0) SL = NormalizeDouble(TP-Point*spread,digits);
            else SL=0;
         if (temp!=0) TP = NormalizeDouble(temp-Point*spread,digits);
            else TP=0;
         }
      }
   else
      {
      openType=Type;
      }   
//----

   if (lots==0) return;
   
   RefreshRates();
   double price;
   color Color;
   if (openType==OP_BUY) 
      {
      price = Ask;
      Color = Blue; 
      }
   if (openType==OP_SELL) 
      {
      price=Bid;
      Color = Red; 
      }
   bool ticket = OrderSend(Symbol(),openType,lots,price,Slippage,SL,TP,comment,ExpertMagicNumber,0,Color); 
   if (ticket<0)
      {
      Print("     ");
      Print("Type=",openType,"  lots=",lots,"  SL=",SL,"  TP=",TP," comment=",comment,"  ExpertMagicNumber=",ExpertMagicNumber);
      //    ,  
      }
//----
   return;
   }

//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
void SendPendingOrder(bool   reversTrade,//   
                      int    Type,
                      double OpenPrice, 
                      double Lots, 
                      double SL, 
                      double TP,
                      string comment)
   {
   if (Type==-1) return; 
   
   if (reversTrade)                       //  
      {
      double temp;
      int spread = MarketInfo(Symbol(),MODE_SPREAD);
      int digits = MarketInfo(Symbol(),MODE_DIGITS);

      if (Type==OP_BUYLIMIT || Type==OP_BUYSTOP)
         {
         OpenPrice = NormalizeDouble(OpenPrice - spread*Point,digits);
         temp=SL;
         SL = NormalizeDouble(TP+Point*spread,digits);
         TP = NormalizeDouble(temp+Point*spread,digits);
         }
      if (Type==OP_SELLLIMIT || Type==OP_SELLSTOP)
         {
         OpenPrice = NormalizeDouble(OpenPrice + spread*Point,digits);
         temp=SL;
         SL = NormalizeDouble(TP - Point*spread,digits);
         TP = NormalizeDouble(temp - Point*spread,digits);
         }

      switch (Type)
         {
         case OP_BUYLIMIT:  Type = OP_SELLSTOP ; break;
         case OP_SELLLIMIT: Type = OP_BUYSTOP  ; break;
         case OP_BUYSTOP:   Type = OP_SELLLIMIT; break;
         case OP_SELLSTOP:  Type = OP_BUYLIMIT;  break;
         default: Print("   Type=",Type,"   SendPendingOrder()!!!");                           
         
         }
      }
   color Color;
   if (Type==OP_SELLLIMIT || Type==OP_SELLSTOP) Color = Red;
   if (Type==OP_BUYLIMIT || Type==OP_BUYSTOP)   Color = Blue;

   bool res = OrderSend(Symbol(),Type,Lots,OpenPrice,Slippage,SL,TP,comment,ExpertMagicNumber,0,Color); 
   if (!res)
      {
      Print("    ");
      //    ,  
      }


//----

//----
   return;
   }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   //       
   ArrayResize(Tickets,0);
   //ArrayResize(CommentsTicket,0);
   
   //    
   PrepareTickets(Tickets,CommentsTicket,ExpertMagicNumber);
   
//----

/**
      1. Trade Signals .   
      a)                         (TradeSignalEveryTick=true)
      )         (TradeSignalBarPeriod=...)
      OP_BUY      -  
      OP_SELL     -  
      OP_BALANCE  -  
*/


   int trSignal=getTradeSignal(TradeDay,ReversDay,
                       TradeSignalEveryTick,TradeSignalBarPeriod);
                       
/**
      2. 
        )  SL  TP    
        )  OpenPrice, SL, TP,  Lots   
        )  OpenPrice, SL  TP    
*/

   CalculateSL_and_TP(ReversTradeSignal,Tickets,newSL_and_TP);


   double marketLots,marketSL,marketTP;
   int marketType, pendingType;
   string marketComment, pendingComment;
   double pendingOpenPrice, pendingLots, pendingSL, pendingTP;

   CalculateNewMarketValues(trSignal, marketType, marketLots,marketSL,marketTP,marketComment);
   CalculateNewPendingValues(trSignal, pendingType, pendingOpenPrice, pendingLots, pendingSL, pendingTP, pendingComment);

/**
      3. 
        )        (SL  TP)        
               (ModifyMarketOrderEveryTick = true)
               
        )        (OpenPrice, SL  TP)
               (ModifyPendingEveryTick = true)
        
        )           (SL  TP)
               (ModifyMarketBarPeriod = ...)
        
        )           (OpenPrice, SL  TP)
               (ModifyPendingBarPeriod = ...)
        
*/

   ModifyMarkets(ReversTradeSignal,ModifyMarketOrderEveryTick,ModifyMarketBarPeriod,newSL_and_TP);
   ModifyPendings(ReversTradeSignal,ModifyPendingEveryTick,ModifyPendingBarPeriod,newSL_and_TP);

/**
      4. 
        )     
        )     
*/
   //  ,   
   int ticketsToClose[][2];
   double lotsToClose[]; 
   
   //   
   ArrayResize(ticketsToClose,0);
   ArrayResize(lotsToClose,0);
   
   //     
   if (trSignal!=OP_BALANCE) PrepareTicketsToClose(trSignal,ReversTradeSignal,ticketsToClose,lotsToClose,Tickets);
   
   //   
   CloseMarketOrders(ticketsToClose,lotsToClose);

/**
      5. 
        )     
        )     
*/
   //  ,   
   int ticketsToDelete[];

   //     
   if (trSignal!=OP_BALANCE) PrepareTicketsToDelete(trSignal,ReversTradeSignal,ticketsToDelete,Tickets);

   //   
   DeletePendingOrders(ticketsToDelete);

/**
      6. 
        )    
        )      
        )       
*/

   if (trSignal!=OP_BALANCE) OpenMarketOrder(ReversTradeSignal,marketType,marketLots,marketSL,marketTP,marketComment);
   if (trSignal!=OP_BALANCE) SendPendingOrder(ReversTradeSignal,pendingType,pendingOpenPrice, pendingLots, pendingSL, pendingTP,pendingComment);
//----
   return(0);
  }
//+------------------------------------------------------------------+